﻿using UnityEngine;
using System.Collections;

public class Tentacle : MonoBehaviour
{
    Collider2D cldr;
    public int Player = 1;
    public KeyCode key;
    Wave wave;
    SpriteRenderer sr;
	// Use this for initialization
	void Start ()
    {
        cldr = GetComponent<Collider2D>();
        cldr.enabled = false;
        wave = transform.parent.GetComponent<Wave>();
        body = GetComponent<Rigidbody2D>();
        y = transform.localPosition.y;

        sr = GetComponent<SpriteRenderer>();
        RandomSprite();
    }

    void RandomSprite()
    {
        transform.localScale = new Vector3(-transform.localScale.x, 1, 1);
        sr.sprite = Global.self.Tentacles[Player - 1, Random.Range(0, 4)];
    }

    void Update ()
    {
        if (!Global.self.gameover)
        {
            if (Input.GetKeyDown(key))
            {
                cldr.enabled = true;
                wave.Key(true, Player);
                StopAllCoroutines();
                StartCoroutine(Up());
            }

            if (Input.GetKeyUp(key))
            {
                cldr.enabled = false;
                wave.Key(false, Player);
                StopAllCoroutines();
                StartCoroutine(Down());
            }
        }
        else
        {
            StopAllCoroutines();
            StartCoroutine(Down());
        }
    }
    Rigidbody2D body;
    float y;
    float speed = 20;
    float deltaY = 3.5f;
    public IEnumerator Up()
    {
        while (transform.localPosition.y < y + deltaY)
        {
            Vector2 pos = Vector2.zero;
            pos.y += speed * Time.deltaTime;
            pos = transform.TransformPoint(pos);
            //Debug.Log(transform.position.ToString() + ' ' + pos.ToString());
            body.MovePosition(pos);
            //transform.Translate(0, speed * Time.deltaTime, 0);
            yield return new WaitForEndOfFrame();
        }

        yield break;
    }

    public IEnumerator Down()
    {
        while (transform.localPosition.y > y)
        {
            Vector2 pos = Vector2.zero;
            pos.y -= speed / 2 * Time.deltaTime;
            pos = transform.TransformPoint(pos);
            body.MovePosition(pos);
            //transform.Translate(0, -speed/2 * Time.deltaTime, 0);
            yield return new WaitForEndOfFrame();
        }
        RandomSprite();

        yield break;
    }
}
